package generics;

import java.util.List;

public class BoxUtil {

	   public static <U> void fillBoxes(U u, List<Box<U>> boxes) {
	        for (Box<U> box : boxes) {
	            box.add(u);
	        }
	    }
	   
	   public static <U extends Number> Double add(U i, U j) {
		   return new Double(i.doubleValue() + j.doubleValue());
	   }

	   public static <U extends Number> Box<Double> add(Box<U> firstBox, Box<U> secondBox){
	      Box<Double> resultBox = new Box<Double>();
	      resultBox.add(add(firstBox.get(),secondBox.get()));
	      return resultBox;
	   }
	   
	   public static void main(String [] args) {
		   	Box<Double> b1 = new Box<Double>(); 
		   	b1.add(new Double(17.5));		   	
		   	Box<Double> b2 = new Box<Double>(); 
		   	b2.add(new Double(45.7));
		   	
		   	Box<Double> b3 = add(b1,b2);
		   	System.out.println(b3.get());
		   	
		   	Box<Integer> b4 = new Box<Integer>(); 
		   	b4.add(new Integer(77));		   	
		   	Box<Integer> b5 = new Box<Integer>(); 
		   	b5.add(new Integer(3));
		   	
		   	Box<Double> b6 = add(b4,b5);
		   	System.out.println(b6.get());
		   	
	   }

}
