package higherOrderProgramming;

import java.util.List;
import java.util.ArrayList;

public class Test {
	
	
	public static void printIntList(List<Integer> list) {
		System.out.print("[");
		if (list.size()>=1)
			System.out.print(list.get(0));
		if (list.size()>1) 
			for (int i=1; i<list.size(); i++)
				System.out.print(", "+list.get(i));
		System.out.println("]");
	}
	
	public static <Any> void printList(List<Any> list) {
		System.out.print("[");
		if (list.size()>=1)
			System.out.print(list.get(0));
		if (list.size()>1) 
			for (int i=1; i<list.size(); i++)
				System.out.print(", "+list.get(i));
		System.out.println("]");
	}
	

	public static void main(String[] args) {
	
		List<Integer> myIntegerList = new ArrayList<Integer>();
		myIntegerList.add(4);
		myIntegerList.add(13);
		myIntegerList.add(5);
		printIntList(myIntegerList);
		
		List<Integer> myIntegerListSquare = ListMap.integerListSquare(myIntegerList);
		printIntList(myIntegerListSquare);

		List<Integer> mySecondIntegerListSquare = ListMap.integerListMap(myIntegerList,new Square());
		printIntList(mySecondIntegerListSquare);
		
		List<Integer> myThirdIntegerListSquare 
		= ListMap.integerListMap(
				myIntegerList,
				new IntegerToInteger(){ Integer apply(Integer i) { return i * i; } });
		printIntList(myThirdIntegerListSquare);
		
		List<Integer> myFourthIntegerListSquare
		= ListMap.listMap(
				myIntegerList,
				new Function<Integer>(){ Integer apply(Integer i) { return i * i; } });
		printIntList(myFourthIntegerListSquare);
		
		Function<Integer> squareAfterInc
		= Function.compose(new Function<Integer>(){ Integer apply(Integer i) { return i * i; } },
						   new Function<Integer>(){ Integer apply(Integer i) { return i + 1; } });
		
		System.out.println(squareAfterInc.apply(6));
		
		Function<Function<Integer>> applyTwice
		= new Function<Function<Integer>>(){ Function<Integer> apply(final Function<Integer> f) { return Function.compose(f,f); } };

		Function<Integer> powerFour 
		= applyTwice.apply(new Function<Integer>(){ Integer apply(Integer i){ return i * i; } });
		
		System.out.println(powerFour.apply(3));
	}

}
